unit SoundPlay;

interface

uses SysUtils, Classes,
{$IFDEF UNIX}
CThreads,
{$ENDIF} openal;


type
pl = class(TThread)
private
    { Private declarations }
public
Play:^boolean;
FirstSource: TALuint; //     
                                      //    /,  
                                      //  /
protected
//    procedure UpdateCaption;
procedure Execute; override;

end;



type PlayMusic = class

private
MainDevice: TALCdevice; //     
MainContext: TALCcontext; //   
FirstBuffer:TALuint; //       
PlayMus:array of Boolean;
// 5          
  format: TALenum;
  data: TALvoid;
  size: TALsizei;
  freq: TALsizei;
  loop: TALint;


ListSound,NameSound:TStringList;
potok:pl;
slash:string;
public
 
function LoadSoundFromInf(InfFile:string): boolean;
function PlayByIndex(Index:integer): boolean;
function PlayByName(s:string): boolean;



end;

implementation


var
slash:string;
//      , X,Y,Z   
  listenerpos: array [0..2] of TALfloat= ( 0.0, 0.0, 0.0);  //
  listenervel: array [0..2] of TALfloat= ( 0.0, 0.0, 0.0);  //
  listenerori: array [0..5] of TALfloat= ( 0.0, 0.0, -1.0, 0.0, 1.0, 0.0); //
//,    
//     ( ..)
//   ,      TALfloat
//   
sourcepos: array [0..2] of TALfloat= ( 0.0, 0.0, 0.0 ); // 
sourcevel: array [0..2] of TALfloat= ( 0.0, 0.0, 0.0 ); //   


function PlayMusic.LoadSoundFromInf(InfFile:string): boolean;
var i:integer;
SoundInf:TStringList;
curdir:string;
begin
{$IFDEF UNIX} slash:='/' {$ELSE IF} slash:='\' {$ENDIF};
curdir:=GetCurrentDir;
result:=false;
SoundInf:=TStringList.Create;
ListSound:=TStringList.Create;
NameSound:=TStringList.Create;
If FileExists(InfFile) then
  begin
  result:=true;
  SoundInf.LoadFromFile(InfFile);
  InitOpenAL;
  MainDevice := alcOpenDevice(nil); //   , nil    
                                  //     
  MainContext := alcCreateContext(MainDevice,nil);
  //   
  //,   - 
  // ,   
  //,  nil
  alcMakeContextCurrent(MainContext); //  
  SetLength(PlayMus,SoundInf.Capacity);
  for I := 0 to SoundInf.Count - 1 do
    begin
    potok:=pl.Create(true);
    ListSound.Add(curdir+slash+copy(SoundInf[i],0, Pos(' ', SoundInf[i])-1));
    NameSound.Add(copy(SoundInf[i],Pos(' ', SoundInf[i])+1,length(SoundInf[i])-(Pos(' ', SoundInf[i]))));
    alGenBuffers(1, @FirstBuffer);
    //        
    //  FirstBuffer
    alutLoadWAVFile(ListSound.Strings[i],format,data,size,freq,loop);
    //  
    // wav-  
    alBufferData(FirstBuffer,format,data,size,freq);
    //   
    //  
    alutUnloadWAV(format,data,size,freq); // 
    alGenSources(1,@potok.FirstSource); //     
    // alSourcei, alSourcefv   ,   
    //,     - ,    , 
    //  ,  -     
    alSourcei ( potok.FirstSource, AL_BUFFER, FirstBuffer); //    
    alSourcefv ( potok.FirstSource, AL_POSITION, @sourcepos); // 
    alSourcefv ( potok.FirstSource, AL_VELOCITY, @sourcevel); //  
    alSourcei ( potok.FirstSource, AL_LOOPING, AL_FALSE);
    //  
    //    -  

    //  ,      ,  
    //  ,      
    alListenerfv(AL_POSITION,@listenerPos); //
    alListenerfv(AL_VELOCITY,@listenerVel); //
    alListenerfv(AL_ORIENTATION,@listenerOri); // 
    potok.Play:=@PlayMus[i];
    potok.Resume;
    end;
  end;
end;

function PlayMusic.PlayByIndex(Index:integer): boolean;
begin
result:=false;
if Length(PlayMus)>=Index+1 then
  begin
  PlayMus[Index]:=True;
  result:=true;
  end;
end;

function PlayMusic.PlayByName(s:string): boolean;
begin
result:=false;
if  NameSound.IndexOf(s) >=0 then
    begin
    PlayMus[NameSound.IndexOf(s)]:=true;
    result:=true;
    end;
end;


procedure pl.Execute;
begin
repeat
if Play^ then
  begin
  Play^:=false;
  alSourcePlay(FirstSource);
  end;
Sleep(100);
until Terminated;

end;
end.
